VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ParagraphFormat"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Description = "Edanmo's RichEdit Control v3 - ParagraphFormat Class"
'*********************************************************************************************
'
' RichEdit Control
'
' ParagraphFormat class
'
'*********************************************************************************************
'
' Author: Eduardo A. Morcillo
' E-Mail: e_morcillo@yahoo.com
' Web Page: http://www.domaindlx.com/e_morcillo
'
' Distribution: You can freely use this code in your own applications but you
'               can't publish this code in a web site, online service, or any
'               other media, without my express permission.
'
' Usage: at your own risk.
'
' Tested on: Windows 98 + VB5
'
' History:
'           07/11/2000 - This code was released
'
'*********************************************************************************************
Option Explicit

Dim m_Para As ITextPara

Enum reAlignment
   reLeft = tomAlignLeft
   reRight = tomAlignRight
   reCenter = tomAlignCenter
   reJustify = tomAlignJustify
   reDecimal = tomAlignDecimal
End Enum

Enum reListTypes
   reListNone
   reListBullet
   reListNumberAsArabic
   reListNumberAsLCLetter
   reListNumberAsUCLetter
   reListNumberAsLCRoman
   reListNumberAsUCRoman
   reListNumberAsSequence
   reListFlagsParentheses = &H10000
   reListFlagsPeriod = &H20000
   reListFlagsPlain = &H30000
End Enum

Enum reLineSpacingRules
   reLineSpaceSingle = tomLineSpaceSingle
   reLineSpace1pt5 = tomLineSpace1pt5
   reLineSpaceDouble = tomLineSpaceDouble
   reLineSpaceAtLeast = tomLineSpaceAtLeast
   reLineSpaceExactly = tomLineSpaceExactly
   reLineSpaceMultiple = tomLineSpaceMultiple
End Enum

Enum reLeaderChars
   reLeaderSpaces
   reLeaderDots
   reLeaderDashes
   reLeaderLines
   reLeaderThickLines
   reLeaderEquals
End Enum

Enum reGetTabs
   rePreviousTab = -3
   reNextTab = -2
   reThisPos = -1
End Enum

Public Sub AddTab(ByVal Pos As Single, Optional ByVal Alignment As reAlignment = reLeft, Optional ByVal Leader As reLeaderChars = reLeaderSpaces)
   m_Para.AddTab Pos, Alignment, Leader
End Sub

Public Property Get Alignment() As reAlignment
   Alignment = m_Para.Alignment
End Property

Public Property Let Alignment(ByVal New_Alignment As reAlignment)
   m_Para.Alignment = New_Alignment
End Property

Public Property Get AutoHyphenation() As Long
   AutoHyphenation = m_Para.Hyphenation
End Property

Public Property Let AutoHyphenation(ByVal New_AutoHyphenation As Long)
   m_Para.Hyphenation = New_AutoHyphenation
End Property

Public Sub ClearAllTabs()
   m_Para.ClearAllTabs
End Sub

Public Sub DeleteTab(ByVal Position As Single)
   m_Para.DeleteTab Position
End Sub

Public Function Duplicate() As ParagraphFormat
   Set Duplicate = New ParagraphFormat
   Set Duplicate.frPara = m_Para.Duplicate
End Function

Public Property Get FirstLineIndent() As Single
   FirstLineIndent = m_Para.FirstLineIndent
End Property

Public Property Let FirstLineIndent(ByVal New_FirstLineIndent As Single)
   m_Para.SetIndents New_FirstLineIndent, LeftIndent, RightIndent
End Property

Friend Property Set frPara(Para As ITextPara)
   Set m_Para = Para
End Property

Friend Property Get frPara() As ITextPara
   Set frPara = m_Para
End Property

Public Sub GetTab(ByVal TabIndex As reGetTabs, Optional Position As Single, Optional Alignment As reAlignment, Optional Leader As reLeaderChars)
   m_Para.GetTab TabIndex, Position, Alignment, Leader
End Sub

Public Property Get KeepTogether() As Long
   KeepTogether = m_Para.KeepTogether
End Property

Public Property Let KeepTogether(ByVal New_KeepTogether As Long)
   m_Para.KeepTogether = New_KeepTogether
End Property

Public Property Get KeepWithNext() As Long
   KeepWithNext = m_Para.KeepWithNext
End Property

Public Property Let KeepWithNext(ByVal New_KeepWithNext As Long)
   m_Para.KeepWithNext = New_KeepWithNext
End Property

Public Property Get LeftIndent() As Single
   LeftIndent = m_Para.LeftIndent
End Property

Public Property Let LeftIndent(ByVal New_LeftIndent As Single)
   m_Para.SetIndents FirstLineIndent, New_LeftIndent, RightIndent
End Property

Public Property Get LineSpacing() As Single
   LineSpacing = m_Para.LineSpacing
End Property

Public Property Let LineSpacing(ByVal New_LineSpacing As Single)
   m_Para.SetLineSpacing LineSpacingRule, New_LineSpacing
End Property

Public Property Get LineSpacingRule() As reLineSpacingRules
   LineSpacingRule = m_Para.LineSpacingRule
End Property

Public Property Let LineSpacingRule(ByVal New_LineSpacingRule As reLineSpacingRules)
   m_Para.SetLineSpacing New_LineSpacingRule, LineSpacing
End Property

Public Property Get ListAlignment() As reAlignment
   ListAlignment = m_Para.ListAlignment
End Property

Public Property Let ListAlignment(ByVal New_ListAlignment As reAlignment)
   m_Para.ListAlignment = New_ListAlignment
End Property

Public Property Get ListLevel() As Long
   ListLevel = m_Para.ListLevelIndex
End Property

Public Property Let ListLevel(ByVal New_ListLevel As Long)
   m_Para.ListLevelIndex = New_ListLevel
End Property

Public Property Get ListStart() As Long
   ListStart = m_Para.ListStart
End Property

Public Property Let ListStart(ByVal New_ListStart As Long)
   m_Para.ListStart = New_ListStart
End Property

Public Property Get ListTab() As Single
   ListTab = m_Para.ListTab
End Property

Public Property Let ListTab(ByVal New_ListTab As Single)
   m_Para.ListTab = New_ListTab
End Property

Public Property Get ListType() As reListTypes
   ListType = m_Para.ListType
End Property

Public Property Let ListType(ByVal New_ListType As reListTypes)
   m_Para.ListType = New_ListType
End Property

Public Property Get NoLineNumber() As Long
   NoLineNumber = m_Para.NoLineNumber
End Property

Public Property Let NoLineNumber(ByVal New_NoLineNumber As Long)
   m_Para.NoLineNumber = New_NoLineNumber
End Property

Public Property Get OutlineLevel() As Long
Dim lStyle As Long

   lStyle = m_Para.Style

   If lStyle > -11 And lStyle < -1 Then
      OutlineLevel = -lStyle - 1
   Else
      OutlineLevel = 0
   End If

End Property

Public Property Let OutlineLevel(ByVal New_Level As Long)

   If New_Level > 9 Or New_Level < 0 Then Err.Raise 5, ERR_SOURCE

   m_Para.Style = -New_Level - 1

End Property
Public Property Get PageBreakBefore() As Long
   PageBreakBefore = m_Para.PageBreakBefore
End Property

Public Property Let PageBreakBefore(ByVal New_PageBreakBefore As Long)
   m_Para.PageBreakBefore = New_PageBreakBefore
End Property

Public Property Get RightIndent() As Single
   RightIndent = m_Para.RightIndent
End Property

Public Property Let RightIndent(ByVal New_RightIndent As Single)
   m_Para.RightIndent = New_RightIndent
End Property

Public Property Get SpaceAfter() As Single
   SpaceAfter = m_Para.SpaceAfter
End Property

Public Property Let SpaceAfter(ByVal New_SpaceAfter As Single)
   m_Para.SpaceAfter = New_SpaceAfter
End Property

Public Property Get SpaceBefore() As Single
   SpaceBefore = m_Para.SpaceBefore
End Property

Public Property Let SpaceBefore(ByVal New_SpaceBefore As Single)
   m_Para.SpaceBefore = New_SpaceBefore
End Property

Public Property Get TabCount() As Long
   TabCount = m_Para.TabCount
End Property

Public Property Get WidowControl() As Long
   WidowControl = m_Para.WidowControl
End Property

Public Property Let WidowControl(ByVal New_WidowControl As Long)
   m_Para.WidowControl = New_WidowControl
End Property

