VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "RTFWrapper"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Implements IRichEditOleCallback         ' To Handle Drag and Drop

Private m_hMe As Long                   ' Handle du Custom Control
Private m_hParent As Long               ' Fenetre parent du Custom Control
Private m_nNotifMessage As Long         ' Message pour notifier les venements en retour

Private m_oDocument As ITextDocument      ' Document object
Private m_oStorage As IStorage

Public Enum ERECFileTypes
    SF_TEXT = &H1
    SF_RTF = &H2
End Enum

Public Property Let BackColor(ByVal New_BackColor As OLE_COLOR)

      ' Set the background
      SendMessage m_hMe, EM_SETBKGNDCOLOR, ByVal 0, ByVal New_BackColor

End Property

Public Property Get Font() As RichFont
   Dim Selection As Selection
   
   ' Create a new Selection object
   Set Selection = New Selection

   ' Set the selection
   Selection.frInitialize m_hMe, m_oDocument.Selection
        
   Set Font = Selection.Range.Font
    
End Property
Public Property Get MaxLength() As Long
   MaxLength = SendMessage(m_hMe, EM_GETLIMITTEXT, 0&, ByVal 0&)
End Property
Public Property Let MaxLength(ByVal New_MaxLength As Long)
   SendMessage m_hMe, EM_EXLIMITTEXT, 0, ByVal New_MaxLength
End Property
Public Property Get ReadOnly() As Boolean
Dim lStyle As Long
    
    lStyle = GetWindowLong(m_hMe, GWL_STYLE)
    If (lStyle And ES_READONLY) = ES_READONLY Then
        ReadOnly = True
    End If

End Property
Public Property Let ReadOnly(ByVal bState As Boolean)
    
    If bState = False Then
        SendMessage m_hMe, EM_SETREADONLY, 0, 0
    Else
        SendMessage m_hMe, EM_SETREADONLY, 1, 0
    End If

End Property
Public Property Let RightToLeft(ByVal New_RightToLeft As Boolean)
Dim lExStyles As Long

   ' Get the extended style flags
   lExStyles = GetWindowLong(m_hMe, GWL_EXSTYLE)

   ' Change the flags
   If New_RightToLeft Then
      lExStyles = lExStyles Or WS_EX_RTLREADING Or WS_EX_LEFTSCROLLBAR
   Else
      lExStyles = lExStyles And Not (WS_EX_RTLREADING Or WS_EX_LEFTSCROLLBAR)
   End If

   ' Set the new flags
   SetWindowLong m_hMe, GWL_EXSTYLE, lExStyles

   ' Force an update
   SetWindowPos m_hMe, 0, 0, 0, 0, 0, SWP_NOMOVE Or SWP_NOSIZE Or SWP_NOZORDER Or SWP_FRAMECHANGED

End Property
' Returns the Selection object.
'
Public Property Get Selection() As Selection

   ' Create a new Selection object
   Set Selection = New Selection

   ' Set the selection
   Selection.frInitialize m_hMe, m_oDocument.Selection

End Property
Public Property Let Redraw(ByVal bState As Boolean)
    If Not (bState) Then
       ' Don't redraw:
       SendMessageLong m_hMe, WM_SETREDRAW, 0, 0
    Else
       ' Redraw again:
       SendMessageLong m_hMe, WM_SETREDRAW, 1, 0
       InvalidateRectAsNull m_hMe, 0, 1
       UpdateWindow m_hMe
    End If
End Property
Public Sub SetSelectedContents(ByRef sText As String, _
                                        ByVal bRTF As Boolean, _
                                        ByVal bSelection As Boolean)
Dim tStream As EDITSTREAM
Dim lR As Long
Dim nwParam As Long

   ' Don't redraw:
   Redraw = False
   ' Insert the text:
   tStream.dwCookie = m_hMe
   tStream.pfnCallback = plAddressOf(AddressOf LoadCallBack)
   tStream.dwError = 0
   StreamText = sText
   
   If bRTF Then
    nwParam = SF_RTF
   Else
    nwParam = SF_TEXT
   End If
   
   If bSelection Then
    nwParam = nwParam Or SFF_SELECTION
   End If
   
   ' The text will be streamed in though the LoadCallback function:
   lR = SendMessage(m_hMe, EM_STREAMIN, nwParam, tStream)
   ' Redraw again:
   Redraw = True
   
End Sub
Public Function GetSelectedContents(ByVal bRTF As Boolean, ByVal bSelection As Boolean) As String
Dim tStream As EDITSTREAM
Dim nwParam As Long
   
   tStream.dwCookie = m_hMe
   tStream.pfnCallback = plAddressOf(AddressOf SaveCallBack)
   tStream.dwError = 0
   
   ' The text will be streamed out though the SaveCallback function:
   ClearStreamText
   If bRTF Then
        nwParam = SF_RTF
   Else
        nwParam = SF_TEXT
   End If
   
   If bSelection Then
    nwParam = nwParam Or SFF_SELECTION
   End If
   
   SendMessage m_hMe, EM_STREAMOUT, nwParam, tStream
   
   ClearRichEdit
   
   GetSelectedContents = StreamText()

End Function
Public Property Let Zoom(ByVal New_Zoom As Long)
Dim Numerator As Long, Denominator As Long
   
   If New_Zoom < 2 Or New_Zoom > 500 Then Exit Property

   If New_Zoom = 100 Then
      ' Remove zoom
      Numerator = 0
      Denominator = 0
   Else
      If New_Zoom < 100 Then
         Numerator = New_Zoom
         Denominator = 100
      Else
         Numerator = New_Zoom / 1.960784
         Denominator = 51
      End If
   End If
   
   ' Set the new zoom
   SendMessage m_hMe, EM_SETZOOM, Numerator, ByVal Denominator

End Property
Public Sub GetSelection(ByRef lStart As Long, ByRef lEnd As Long)
Dim tCR As CHARRANGE
   SendMessage m_hMe, EM_EXGETSEL, 0, tCR
   lStart = tCR.cpMin
   lEnd = tCR.cpMax
End Sub
Public Sub SetSelection(ByVal lStart As Long, ByVal lEnd As Long)
Dim tCR As CHARRANGE
   tCR.cpMin = lStart
   tCR.cpMax = lEnd
   SendMessage m_hMe, EM_EXSETSEL, 0, tCR
End Sub
'
' Range
'
' Returns a text range
'
Public Function Range(Optional ByVal StartPos, Optional ByVal EndPos) As Range
Dim oTR As ITextRange

   If IsMissing(StartPos) And IsMissing(EndPos) Then
      ' Return the complete document
      Set oTR = m_oDocument.Range
      oTR.Expand tomStory

   ElseIf IsMissing(StartPos) Then

      ' Return from the begining to EndPos
      Set oTR = m_oDocument.Range(0, EndPos)

   ElseIf IsMissing(EndPos) Then

      ' Return range from StartPos to the
      ' end of the document
      Set oTR = m_oDocument.Range(StartPos, &H7FFFFFFF)

   Else

      ' Return range from StartPos to EndPos
      Set oTR = m_oDocument.Range(StartPos, EndPos)

   End If

   Set Range = New Range
   Set Range.Range = oTR

End Function

'##########################################################
Public Function AttachWindow(ByVal hWnd As Long, ByVal phParent As Long, ByVal pnNotifMessage As Long) As Long
    Dim oREO As IRichEditOle
    Dim oREOC As IRichEditOleCallback
    Dim oUnk As olelib.IUnknown
    
    ' Get the document object
    SendMessage hWnd, EM_GETOLEINTERFACE, 0&, oREO
    If oREO Is Nothing Then
        MsgBox "Cannot attach IRichEditOle !!"
        AttachWindow = -1
    End If
    
    Set m_oDocument = oREO
    ' Set the OLE callback
    SendMessageOC hWnd, EM_SETOLECALLBACK, 0&, Me

    ' The RichEdit control calls AddRef on
    ' the callback object (this control).
    ' Decrement the reference count to make
    ' the RichEdit reference a weak reference.
     Set oUnk = Me
     oUnk.Release
     Set oUnk = Nothing
     
    m_hMe = hWnd
    m_hParent = phParent
    m_nNotifMessage = pnNotifMessage
    AttachWindow = 1
End Function
Public Function DetachWindow(ByVal hWnd As Long) As Long
   Dim oUnk As olelib.IUnknown

   ' Increment the control reference
   ' count to make the instance owned
   ' by the RichEdit control a strong
   ' reference.
   Set oUnk = Me
   oUnk.AddRef
   Set oUnk = Nothing

   SendMessageOC hWnd, EM_SETOLECALLBACK, 0, Nothing

End Function
'##########################################################
Private Sub IRichEditOleCallback_GetDragDropEffect(ByVal fDrag As Long, ByVal grfKeyState As Long, pdwEffect As Long)
    ' Sends message to parent to know Drag Drop effect wanted
    pdwEffect = SendMessage(m_hMe, m_nNotifMessage + 40, fDrag, 0)
End Sub
Private Sub IRichEditOleCallback_GetClipboardData( _
      lpchrg As olelib.CHARRANGE, _
      ByVal reco As Long, _
      lplpdataobj As olelib.IDataObject)
    Err.Raise E_NOTIMPL
End Sub
Private Sub IRichEditOleCallback_GetNewStorage(lplpstg As olelib.IStorage)
Dim oREO As IRichEditOle
   Set oREO = m_oDocument
   Set lplpstg = m_oStorage.CreateStorage( _
                     "Object " & oREO.GetObjectCount, _
                     STGM_CREATE Or STGM_READWRITE Or _
                     STGM_SHARE_EXCLUSIVE)

End Sub
Private Sub IRichEditOleCallback_QueryAcceptData( _
   ByVal lpdataobj As olelib.IDataObject, _
   lpcfFormat As Integer, _
   ByVal reco As Long, _
   ByVal fReally As Long, _
   ByVal hMetaPict As Long)
Dim tFMT As olelib.FORMATETC
Dim oEF As IEnumFORMATETC
Dim aFormats() As Integer
Dim lIdx As Long
    
Dim FMT As olelib.FORMATETC

Dim STM As olelib.STGMEDIUM
Dim lLen As Long
Dim sTextRTF As String
Dim nFormat As Variant

Dim sFormat As String

'    Call SendMessageLong(m_hMe, m_nNotifMessage + 43, 3, fReally)

'   On Error GoTo IgnoreError

   'MsgBox "IRichEditOleCallback_QueryAcceptData"
   ' Enumerate the formats
   Set oEF = lpdataobj.EnumFormatEtc(DATADIR_GET)

   Do While oEF.Next(1, tFMT) = S_OK

      ReDim Preserve aFormats(0 To lIdx)

      aFormats(lIdx) = tFMT.cfFormat
      lIdx = lIdx + 1

   Loop

   If lIdx > 0 Then

      If lpcfFormat = -1 Then Err.Raise E_FAIL

   End If

''''''''''''' Ici, on bloque le drop au moment de le faire et
''''''''''''' on prfre envoyer le texte Brut si l'appli le souhaite
    On Error GoTo ErrTest
    If fReally = 1 Then
    
        If SendMessage(m_hMe, m_nNotifMessage + 45, 0, 0) = 1 Then
            ' Set the FMT structure
            FMT.TYMED = TYMED_HGLOBAL
            FMT.cfFormat = 1                'CF_TEXT
            
            lpdataobj.GetData FMT, STM
            lLen = lstrlenA(STM.Data)
            sTextRTF = Space$(Int((lLen / 2) + 0.51))
            MoveMemory ByVal sTextRTF, ByVal STM.Data, lLen
            
            'MsgBox "Release the data on STM"
            ReleaseStgMedium STM
            
            'MsgBox "Convert the string to Unicode"
            sTextRTF = StrConv(sTextRTF, vbUnicode)
            
            Call SendMessageStr(m_hMe, m_nNotifMessage + 44, Len(sTextRTF), sTextRTF)
            
            lpcfFormat = -1
        End If
    
    End If
    ''''''''''''
    Exit Sub

IgnoreError:
ErrTest:
    MsgBox Err.Description & "/" & Err.Number
    
End Sub
Private Sub IRichEditOleCallback_ContextSensitiveHelp(ByVal fEnterMode As Long)
    MsgBox "IRichEditOleCallback_ContextSensitiveHelp"
End Sub
Private Sub IRichEditOleCallback_DeleteObject(ByVal lpoleobj As olelib.IOleObject)
    MsgBox "IRichEditOleCallback_DeleteObject"
End Sub
Private Sub IRichEditOleCallback_GetContextMenu(ByVal SelType As Integer, ByVal lpoleobj As olelib.IOleObject, lpchrg As olelib.CHARRANGE, lphmenu As Long)
Dim tP As POINTAPI
Dim x As Single, y As Single
               
    GetCursorPos tP
    ScreenToClient m_hMe, tP
    x = tP.x  '* Screen.TwipsPerPixelX
    y = tP.y '* Screen.TwipsPerPixelY
    Call SendMessageLong(m_hMe, m_nNotifMessage + 41, x, y)
End Sub
Private Sub IRichEditOleCallback_GetInPlaceContext(lplpFrame As olelib.IOleInPlaceFrame, lplpDoc As olelib.IOleInPlaceUIWindow, lpFrameInfo As olelib.OLEINPLACEFRAMEINFO)
    MsgBox "IRichEditOleCallback_GetInPlaceContext"
End Sub
Private Sub IRichEditOleCallback_QueryInsertObject(lpclsid As olelib.UUID, ByVal lpstg As olelib.IStorage, ByVal cp As Long)
    MsgBox "IRichEditOleCallback_QueryInsertObject"
End Sub
Private Sub IRichEditOleCallback_ShowContainerUI(ByVal fShow As Long)
    MsgBox "IRichEditOleCallback_ShowContainerUI"
End Sub

Public Sub PrintDoc(ByVal sDocTitle As String)
Dim pd As PrintDlg

   '// Initialize the PRINTDLG structure.
   pd.lStructSize = Len(pd)
   pd.hWndOwner = m_hMe
   pd.hDevMode = 0
   pd.hDevNames = 0
   pd.nFromPage = 0
   pd.nToPage = 0
   pd.nMinPage = 0
   pd.nMaxPage = 0
   pd.nCopies = 0
   pd.hInstance = App.hInstance
   'pd.flags = PD_RETURNDC Or PD_PRINTSETUP Or PD_NOSELECTION
   pd.flags = PD_RETURNDC Or PD_NOPAGENUMS
   
   If Selection().Range().Length = 0 Then
        pd.flags = pd.flags Or PD_NOSELECTION
   End If
   
   pd.lpfnSetupHook = 0
   pd.lpSetupTemplateName = 0
   pd.lpfnPrintHook = 0
   pd.lpPrintTemplateName = 0
   
   '// Get the printer DC.
    If (PrintDlg(pd) <> 0) Then
    
        If (pd.flags And PD_SELECTION) = PD_SELECTION Then
            PrintRange Selection().Range(), pd.hdc, "Test"
        Else
            PrintRange , pd.hdc, "Test"
        End If
        
        '// Delete the printer DC.
        DeleteDC pd.hdc
        
        'm_eProgressType = ercNone
    End If

End Sub
'
' PrintRange
'
' Prints a range on the given DC
'
' Parameters:
'
' Range - Optional. Range to print. Default is all text.
' PrinterDC - Optional. Device context in which the text will be printed.
'             Default is the default printer.
' FirstPage - Optional. Number of the first page to print. Default is 1
' LastPage - Optional. Number of the last page to print. Default is the last page.
Public Sub PrintRange( _
      Optional ByVal Range As Range, _
      Optional ByVal PrinterDC As Long, _
      Optional ByVal Title As String, _
      Optional ByVal FirstPage As Long, _
      Optional ByVal LastPage As Long, _
      Optional ByVal MarginLeft As Long, _
      Optional ByVal MarginTop As Long, _
      Optional ByVal MarginRight As Long, _
      Optional ByVal MarginBottom As Long, _
      Optional ByVal EndDocument As Boolean)
Dim FR As FORMATRANGE
Dim PageRanges() As FORMATRANGE
Dim hdc As Long
Dim lPageWidth As Long, lPageHeight As Long
Dim lDPIX As Long, lDPIY As Long
Dim lHeight As Long, lWidth As Long
Dim MinMargins As RECT
Dim PrintableArea As RECT

Dim lChars As Long, lLastlChars As Long

Dim lPages As Long
Dim lCurPage As Long
Dim lSavedDC As Long
Dim doc As DOCINFO
Dim bCancel As Boolean
Dim Header As String, Footer As String


   ' Reset the formatting buffer
   SendMessage m_hMe, EM_FORMATRANGE, 0, ByVal 0&

   ' Fill the FORMATRANGE structure
   With FR

      If PrinterDC = 0 Then

         ' Use the default printer
         hdc = Printer.hdc

         ' The control has to end the print job
         EndDocument = True

      Else

         ' Check if the DC is a DC of printer
         If GetDeviceCaps(PrinterDC, TECHNOLOGY) <> DT_RASPRINTER Then
            Err.Raise 5, ERR_SOURCE, ERR_INVALIDDC
         End If

         hdc = PrinterDC

      End If
      
      ' Set the DCs
      .hdc = hdc
      .hdcTarget = .hdc

      ' Get a range object for
      ' all the text if no
      ' range was passed to the method
      
      If Range Is Nothing Then
        Set Range = New Range
        Set Range = Me.Range()
      End If
      
      ' Set the range to print
      .chrg.cpMin = Range.StartPos
      .chrg.cpMax = Range.EndPos
              
      ' Check if there's something to print
      If .chrg.cpMax = .chrg.cpMin Then Exit Sub

      ' Get the printer resolution (pixels per inch)
      lDPIX = GetDeviceCaps(hdc, LOGPIXELSX)
      lDPIY = GetDeviceCaps(hdc, LOGPIXELSY)

      ' Get the Width and Height
      lPageWidth = MulDiv(GetDeviceCaps(hdc, PHYSICALWIDTH), 1440&, lDPIX)
      lPageHeight = MulDiv(GetDeviceCaps(hdc, PHYSICALHEIGHT), 1440&, lDPIY)

      ' Get the printable area size in Twips
      lWidth = MulDiv(GetDeviceCaps(hdc, HORZRES), 1440&, lDPIX)
      lHeight = MulDiv(GetDeviceCaps(hdc, VERTRES), 1440&, lDPIY)

      ' Get the minumum margins
      MinMargins.Left = MulDiv(GetDeviceCaps(hdc, PHYSICALOFFSETX), 1440&, lDPIX)
      MinMargins.Top = MulDiv(GetDeviceCaps(hdc, PHYSICALOFFSETY), 1440&, lDPIX)
      MinMargins.Right = lPageWidth - lWidth - MinMargins.Left
      MinMargins.Bottom = lPageHeight - lHeight - MinMargins.Top

      ' Change the margins if they
      ' are below the minimum size
      If MarginLeft < MinMargins.Left Then MarginLeft = MinMargins.Left
      If MarginTop < MinMargins.Top Then MarginTop = MinMargins.Top
      If MarginRight < MinMargins.Right Then MarginRight = MinMargins.Right
      If MarginBottom < MinMargins.Bottom Then MarginBottom = MinMargins.Bottom

      MarginLeft = MarginLeft - MinMargins.Left
      MarginTop = MarginTop - MinMargins.Top
      MarginRight = MarginRight - MinMargins.Right
      MarginBottom = MarginBottom - MinMargins.Bottom


      ' Calculate the printable area
      With PrintableArea
         .Left = MarginLeft
         .Top = MarginTop
         .Right = lWidth - MarginLeft - MarginRight
         .Bottom = lHeight - MarginLeft - MarginBottom
      End With

      ' Set the page size
      .rcPage.Right = lPageWidth
      .rcPage.Bottom = lPageHeight

      ' Set the printable area
      .rc = PrintableArea
      ' Send the first page
      lChars = SendMessage(m_hMe, EM_FORMATRANGE, 0, FR)

      ' Add the first page to the
      ' pages array
      lPages = 1
      ReDim Preserve PageRanges(1 To lPages)
      PageRanges(lPages) = FR
      
      ' EM_FORMATRANGE returns
      ' the position of the last
      ' char printed. We keep printing
      ' from the last char until
      ' there's no more chars to print.
      Do While lChars < FR.chrg.cpMax And lChars <> 0

         ' Move the range
         FR.chrg.cpMin = lChars

         ' Set the printable area
         .rc = PrintableArea

         ' Get the next page
         lLastlChars = lChars
         lChars = SendMessage(m_hMe, EM_FORMATRANGE, 0, FR)
         
         If lChars > lLastlChars Then
             ' Increment the page counter
            lPages = lPages + 1

            ' Redim the pages array and add
            ' the last page to it
            ReDim Preserve PageRanges(1 To lPages)
            PageRanges(lPages) = FR
        Else
            lChars = 0
        End If
      Loop
      
      ' Check page values
      If FirstPage < 1 Then FirstPage = 1
      If LastPage > lPages Or LastPage = 0 Then LastPage = lPages

      ' Raise the Printing event
      '###########RaiseEvent Printing(rePrintStartJob, 0, lPages, bCancel)

      ' Print only if bCancel = False
      If Not bCancel Then

         ' Start the jon
         doc.cbSize = Len(doc)
         If LenB(Title) = 0 Then
            doc.lpszDocName = Title
         Else
            doc.lpszDocName = "RichEdit Control"
         End If

         ' Start the document
         StartDoc hdc, doc
         StartPage hdc
         
         For lCurPage = FirstPage To LastPage
            
'            ' Print the page header
'             Header = Title
'             Printer.CurrentY = 0
'             Printer.CurrentX = 0
'             Printer.Print Header
              'Call TextOut(hdc, MarginLeft, MarginTop, "test header", 11)
            
'            ' Print the page footer
'             Footer = "Page " & lCurPage & "/" & LastPage
'             Printer.CurrentY = Printer.ScaleHeight - 600
'             Printer.CurrentX = (Printer.ScaleWidth - Printer.TextWidth(Header)) / 2
'             Printer.Print Footer

            ' Save the DC state
            lSavedDC = SaveDC(hdc)

            ' Print the page
            SendMessage m_hMe, EM_FORMATRANGE, 1, PageRanges(lCurPage)

            ' Restore the DC state
            RestoreDC hdc, lSavedDC

            '##############"RaiseEvent Printing(rePrintAfterPrintingPage, lCurPage, lPages, bCancel)
            If bCancel Then Exit For

            ' Create a new page if this
            ' page wasn't the last page
            If lCurPage <> LastPage Then
               ' End the page
               EndPage hdc
               StartPage hdc
            End If

         Next

         '############"RaiseEvent Printing(rePrintEndJob, 0, lPages, bCancel)

         If Not bCancel Then 'And EndDocument Then

            ' End the page
            EndPage hdc

            ' End the job
            EndDoc hdc

         End If


      End If

      If bCancel Then

         ' Kill the job
         AbortDoc hdc

      End If

   End With
   
   ' Reset the formatting buffer
   SendMessage m_hMe, EM_FORMATRANGE, 0, ByVal 0&

End Sub
' suppresses all caracters within selection which color is pnColour
Public Sub SuppressSelectionColored(ByVal pnStart As Long, _
                                      ByVal pnLength As Long, _
                                      ByVal pbBack As Boolean, _
                                      ByVal pbBackWithoutSelection As Boolean, _
                                      ByVal pnColour As Long)
                                      
    Dim nStartOrig As Long
    Dim nSelColour As Long
    Dim nSelLength As Long
    Dim nSelected As Long
    Dim nStart As Long
    Dim bRemoved As Boolean
    
    m_oDocument.Freeze
    
    nStartOrig = pnStart
    While pnLength > 0
        
        If pbBack = True Then
            nStart = pnStart + pnLength - 1
        Else
            nStart = pnStart
        End If
        
        Call SetSelection(nStart, nStart + 1)
        nSelected = 1
        
        nSelColour = Font().ForeColor
        If nSelColour = pnColour Then
            Call Selection().ReplaceText("")
            bRemoved = True
        Else
            If Not pbBack Then
                pnStart = pnStart + nSelected
            End If
        End If
        pnLength = pnLength - nSelected
         If pbBackWithoutSelection Then
            If Not bRemoved Then
                nStartOrig = pnStart + 2 - nSelected
            Else
                nStartOrig = pnStart + 1 - nSelected
            End If
        End If
    Wend

   m_oDocument.Unfreeze
    
    Call SetSelection(nStartOrig, nStartOrig)
    
End Sub


