VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "RichFont"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Description = "Edanmo's RichEdit Control v3 - RichFont Class"
'*********************************************************************************************
'
' RichEdit Control
'
' RichFont class
'
'*********************************************************************************************
'
' Author: Eduardo A. Morcillo
' E-Mail: e_morcillo@yahoo.com
' Web Page: http://www.domaindlx.com/e_morcillo
'
' Distribution: You can freely use this code in your own applications but you
'               can't publish this code in a web site, online service, or any
'               other media, without my express permission.
'
' Usage: at your own risk.
'
' Tested on: Windows 98 + VB5
'
' History:
'           07/11/2000 - This code was released
'
'*********************************************************************************************
Option Explicit

Dim m_FontOrg As ITextFont
Dim m_Font As ITextFont
Dim WithEvents m_Std As StdFont
Attribute m_Std.VB_VarHelpID = -1

Public Enum reUnderlineStyles
   reUnderlineNone
   reUnderlineSingle
   reUnderlineWords
   reUnderlineDouble
   reUnderlineDotted
   reUnderlineDash
   reUnderlineDashDot
   reUnderlineDashDotDot
   reUnderlineWave
   reUnderlineThick
   reUnderlineHair
   reUnderlineUnknown = tomUndefined
End Enum

Enum reAnimations
   reAnimNone = tomNoAnimation
   reAnimLasVegasLights = tomLasVegasLights
   reAnimBlinkingBackground = tomBlinkingBackground
   reAnimSparkleText = tomSparkleText
   reAnimMarchingBlackAnts = tomMarchingBlackAnts
   reAnimMarchingRedAnts = tomMarchingRedAnts
   reAnimShimmer = tomShimmer
   reAnimWipeDown = tomWipeDown
   reAnimWipeRight = tomWipeRight
End Enum

Public Property Get AllCaps() As Long
   AllCaps = m_Font.AllCaps
End Property

Public Property Let AllCaps(ByVal New_AllCaps As Long)
   m_Font.AllCaps = New_AllCaps
End Property

'
' Stored in the RTF but not displayed by RichEdit
'
Public Property Get Animation() As reAnimations
   Animation = m_Font.Animation
End Property

'
' Stored in the RTF but not displayed by RichEdit
'
Public Property Let Animation(ByVal New_Animation As reAnimations)
   m_Font.Animation = New_Animation
End Property

Public Property Get BackColor() As Long
   BackColor = m_Font.BackColor
End Property

Public Property Let BackColor(ByVal New_BackColor As Long)

   If New_BackColor = reAutoColor Then
      m_Font.BackColor = New_BackColor
   Else
      'm_Font.BackColor = OleTranslateColor(New_BackColor)
      m_Font.BackColor = New_BackColor
   End If
   
End Property

Public Property Get Bold() As Long
   Bold = m_Font.Bold
End Property

Public Property Let Bold(ByVal New_Bold As Long)
   m_Font.Bold = New_Bold
End Property

'
' Stored in the RTF but not displayed by RichEdit
'
Public Property Get Emboss() As Long
   Emboss = m_Font.Emboss
End Property

'
' Stored in the RTF but not displayed by RichEdit
'
Public Property Let Emboss(ByVal New_Emboss As Long)
   m_Font.Emboss = New_Emboss
End Property

'
' Stored in the RTF but not displayed by RichEdit
'
Public Property Get Engrave() As Long
   Engrave = m_Font.Engrave
End Property

'
' Stored in the RTF but not displayed by RichEdit
'
Public Property Let Engrave(ByVal New_Engrave As Long)
   m_Font.Engrave = New_Engrave
End Property

Public Property Get ForeColor() As Long
   ForeColor = m_Font.ForeColor
End Property

Public Property Let ForeColor(ByVal New_ForeColor As Long)
   
   If New_ForeColor = reAutoColor Then
      m_Font.ForeColor = New_ForeColor
   Else
'      m_Font.ForeColor = OleTranslateColor(New_ForeColor)
      m_Font.ForeColor = New_ForeColor
   End If
   
End Property

Friend Property Get frFont() As ITextFont
   Set frFont = m_Font
End Property

Friend Property Set frFont(ByVal Font As ITextFont)
   Set m_Font = Font
End Property

Public Property Get Hidden() As Long
   Hidden = m_Font.Hidden
End Property

Public Property Let Hidden(ByVal New_Hidden As Long)
   m_Font.Hidden = New_Hidden
End Property

Public Property Get Italic() As Long
   Italic = m_Font.Italic
End Property

Public Property Let Italic(ByVal New_Italic As Long)
   m_Font.Italic = New_Italic
End Property

'
' Stored in the RTF but not displayed by RichEdit
'
Public Property Get Kerning() As Long
   Kerning = m_Font.Kerning
End Property

'
' Stored in the RTF but not displayed by RichEdit
'
Public Property Let Kerning(ByVal New_Kerning As Long)
   m_Font.Kerning = New_Kerning
End Property

Public Property Get LangID() As Long
   LangID = m_Font.LanguageID
End Property

Public Property Let LangID(ByVal New_LangID As Long)
   m_Font.LanguageID = New_LangID
End Property

Public Property Get Name() As String
Attribute Name.VB_UserMemId = 0
   Name = m_Font.Name
End Property

Public Property Let Name(ByVal New_Name As String)
   m_Font.Name = New_Name
End Property

'
' Stored in the RTF but not displayed by RichEdit
'
Public Property Get Outline() As Long
   Outline = m_Font.Outline
End Property

'
' Stored in the RTF but not displayed by RichEdit
'
Public Property Let Outline(ByVal New_Outline As Long)
   m_Font.Outline = New_Outline
End Property

Public Property Get Position() As Single
   Position = m_Font.Position
End Property

Public Property Let Position(ByVal New_Position As Single)
   m_Font.Position = New_Position
End Property

Public Property Get Protected() As Long
   Protected = m_Font.Protected
End Property

Public Property Let Protected(ByVal New_Protected As Long)
   m_Font.Protected = New_Protected
End Property

'
' Stored in the RTF but not displayed by RichEdit
'
Public Property Get Shadow() As Long
   Shadow = m_Font.Shadow
End Property

'
' Stored in the RTF but not displayed by RichEdit
'
Public Property Let Shadow(ByVal New_Shadow As Long)
   m_Font.Shadow = New_Shadow
End Property

Public Property Get SIZE() As Single
   SIZE = m_Font.SIZE
End Property

Public Property Let SIZE(ByVal New_Size As Single)
   m_Font.SIZE = New_Size
End Property

'
' Stored in the RTF but not displayed by RichEdit
'
Public Property Get SmallCaps() As Long
   SmallCaps = m_Font.SmallCaps
End Property

'
' Stored in the RTF but not displayed by RichEdit
'
Public Property Let SmallCaps(ByVal New_SmallCaps As Long)
   m_Font.SmallCaps = New_SmallCaps
End Property
Public Property Get Spacing() As Single
   Spacing = m_Font.Spacing
End Property

Public Property Let Spacing(ByVal New_Spacing As Single)
   m_Font.Spacing = New_Spacing
End Property

Public Property Get StdFont() As StdFont
   Set StdFont = m_Std
End Property

Public Property Set StdFont(ByVal New_StdFont As StdFont)
   Set m_Std = New_StdFont
   m_Std_FontChanged ""
End Property

Public Property Get StrikeThrough() As Long
   StrikeThrough = m_Font.StrikeThrough
End Property

Public Property Let StrikeThrough(ByVal New_StrikeThrough As Long)
   m_Font.StrikeThrough = New_StrikeThrough
End Property

Public Property Get Subscript() As Long
   Subscript = m_Font.Subscript
End Property

Public Property Let Subscript(ByVal New_Subscript As Long)
   m_Font.Subscript = New_Subscript
End Property

Public Property Get Superscript() As Long
   Superscript = m_Font.Superscript
End Property

Public Property Let Superscript(ByVal New_Superscript As Long)
   m_Font.Superscript = New_Superscript
End Property

Public Property Get Underline() As reUnderlineStyles
   Underline = m_Font.Underline
End Property

Public Property Let Underline(ByVal New_Underline As reUnderlineStyles)
   m_Font.Underline = New_Underline
End Property

Public Property Get Weight() As Long
   Weight = m_Font.Weight
End Property

Public Property Let Weight(ByVal New_Weight As Long)
   m_Font.Weight = New_Weight
End Property

Private Sub Class_Initialize()
   Set m_Std = New StdFont
End Sub

Private Sub Class_Terminate()
   Set m_Std = Nothing
   Set m_Font = Nothing
End Sub

Private Sub m_Std_FontChanged(ByVal PropertyName As String)

   With m_Font
      .Name = m_Std.Name
      .SIZE = m_Std.SIZE
      .Bold = m_Std.Bold
      .Italic = m_Std.Italic
      .StrikeThrough = m_Std.StrikeThrough
      .Underline = m_Std.Underline
      .Weight = m_Std.Weight
   End With

End Sub
